; CreateBmpFromMem demo by Vortex

.386
.model flat,stdcall
option casemap:none

include		\GeneSys\include\windows.inc
include		\GeneSys\include\user32.inc
include 	\GeneSys\include\kernel32.inc
include 	\GeneSys\include\gdi32.inc

includelib	\GeneSys\lib\user32.lib
includelib	\GeneSys\lib\kernel32.lib
includelib	\GeneSys\lib\gdi32.lib

WinMain			PROTO :DWORD,:DWORD,:DWORD,:DWORD

CreateBmpFromMem	PROTO :DWORD,:DWORD,:DWORD

EXTERN pBitmap:BYTE

.data
ClassName	db "BitmapClass",0
AppName		db "Bitmap from memory",0

.data?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hBitmap		dd ?
hDC1		dd ?

.code
start:
	invoke	GetModuleHandle, NULL
	mov	hInstance,eax
	invoke	GetCommandLine
	mov	CommandLine,eax
	invoke	WinMain,hInstance,NULL,eax, SW_SHOWDEFAULT
	invoke	ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov	wc.cbSize,SIZEOF WNDCLASSEX
	mov	wc.style, CS_HREDRAW or CS_VREDRAW
	mov	wc.lpfnWndProc, OFFSET WndProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,NULL
	push	hInstance
	pop	wc.hInstance
	mov	wc.hbrBackground,COLOR_WINDOW+1
	mov	wc.lpszMenuName,NULL
	mov	wc.lpszClassName,OFFSET ClassName
	invoke	LoadIcon,NULL,IDI_APPLICATION
	mov	wc.hIcon,eax
	mov	wc.hIconSm,eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov	wc.hCursor,eax
	invoke	RegisterClassEx, ADDR wc
	invoke	CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
		WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
		CW_USEDEFAULT,290,90,NULL,NULL,\
		hInst,NULL
	mov	hwnd,eax
	invoke	ShowWindow, hwnd,SW_SHOWNORMAL
	invoke	UpdateWindow, hwnd
	.WHILE TRUE
		invoke	GetMessage, ADDR msg,NULL,0,0
		.BREAK	.if (!eax)
		invoke	TranslateMessage, ADDR msg
		invoke	DispatchMessage, ADDR msg
	.ENDW
	mov	eax,msg.wParam
	ret
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	LOCAL	ps:PAINTSTRUCT
	LOCAL	hdc:HDC
	LOCAL	hMemDC:HDC

	.IF uMsg==WM_CREATE
		invoke	CreateBmpFromMem,hWnd,ADDR pBitmap,ADDR hDC1
		mov	hBitmap,eax	
          
	.ELSEIF uMsg==WM_PAINT
		invoke	BeginPaint,hWnd,ADDR ps
		mov	hdc,eax
		invoke	CreateCompatibleDC,eax
		mov	hMemDC,eax
		invoke	SelectObject,eax,hBitmap
		lea	edx,[pBitmap+sizeof(BITMAPFILEHEADER)] ; start of the BITMAPINFOHEADER header

	ASSUME edx:ptr BITMAPINFOHEADER	

		invoke	BitBlt,hdc,0,0,[edx].biWidth,[edx].biHeight,hMemDC,0,0,SRCCOPY
		invoke	DeleteDC,hMemDC
		invoke	EndPaint,hWnd,ADDR ps

	ASSUME edx:NOTHING

	.ELSEIF uMsg==WM_DESTROY
		invoke	DeleteObject,hBitmap
		invoke	ReleaseDC,hWnd,hDC1
		invoke	PostQuitMessage,NULL

	.ELSE
		invoke	DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret

	.ENDIF
		xor	eax,eax
		ret

WndProc	ENDP
END start